import requests
import json
import time
import random
import os


def generate_poem(times=4):
    url = "https://pythonanywhere.kylinpoet.workers.dev/https://v1.jinrishici.com/all"
    lst_ret = []
    for i in range(times):
        response = requests.get(url)
        print(response)
        if response.status_code == 200:
            data = response.json()
            content = data.get("content", "No content found")
            lst_ret.append(content)
        else:
            print("Failed to retrieve data")
            return
        time.sleep(0.1)
    return lst_ret


def generate_poem_go(times=4):
    base_dir = os.path.dirname(os.path.abspath(__file__))
    file_path = os.path.join(base_dir, "poems.json")
    with open(file_path, 'r', encoding='utf-8') as f:
        data = json.load(f)
    # 确保数据是列表形式
    if isinstance(data, list):
        # 随机选择times个元素
        selected_items = random.sample(data, min(times, len(data)))
        return selected_items
    else:
        raise ValueError("JSON文件中的数据不是列表形式")


def generate_image(shici_content):
    def pngurl(content):
        import re
        pattern = r'https://[^)]+\.png'
        match = re.search(pattern, content)
        if match:
            image_url = match.group(0)
            return 'https://pythonanywhere.kylinpoet.workers.dev/' + image_url
        else:
            return ''
    # 以下内容根据实际情况配置
    url = "https://pythonanywhere.kylinpoet.workers.dev/http://*.*/v1/chat/completions"
    api_key = 'eyJhbGciOiJIUzI1NiI******'
    contet_prompt=f"""
# 角色：
水墨画艺术家，擅长根据诗词创作水墨画

# 背景信息：
中国诗词往往蕴含着深厚的文化内涵和独特的审美情趣，水墨画作为中国传统艺术形式之一，与诗词有着天然的契合度。水墨画强调意境和留白，通过简约的线条和墨色变化表现丰富的情感和哲理。

# 工作流程/工作任务：
1. 阅读并理解诗词的内容和风格
2. 根据诗词的主题和情感，构思画面的布局和元素
3. 使用水墨画技法，绘制出符合诗词风格的水墨画

# 输出示例：
- 诗词：《静夜思》李白
  - 水墨画：一轮明月高挂天空，月光下一位旅人独坐窗前，周围环境宁静，营造出一种深沉的孤独感和对故乡的思念。
- 诗词：《江雪》柳宗元
  - 水墨画：一片雪白的江面上，一叶小舟孤独地漂浮，舟上一位老翁独自垂钓，四周寂静无声，传达出一种超然物外的宁静和淡泊。

# 注意事项：
- 在绘制过程中，要注重诗词的情感表达和意境营造
- 注意水墨画技法的运用，如墨色的浓淡、线条的流畅等
- 尽量避免过度细节的描绘，保持画面的简约和留白
- 绘制的内容，要符合诗词的内容表达
- 根据内容直接生成水墨画，不要有其它任何回答

内容：{shici_content}
    """
    headers = {
        "Content-Type": "application/json",
        "Authorization": f"Bearer {api_key}"
    }
    data = {
        "model": "GLM-4-AllTools",
        "messages": [
            {"role": "user", "content": f"{contet_prompt}"},
        ],
        "stream": False,
    }
    response = requests.post(url, headers=headers, data=json.dumps(data), timeout=60)
    if response.status_code == 200:
        response_data = response.json()
        json_content = response_data['choices'][0]['message']['content']
        # return json_content
        return pngurl(json_content)
    else:
        print("Error:", response.status_code, response.text)


if __name__ == '__main__':

    print(generate_poem(4))
    # print(generate_image('白日依山尽，黄河入海流'))